image: docker:20
services:
  - docker:20-dind

variables:
  DOCKER_DRIVER: overlay
  SPRING_PROFILES_ACTIVE: gitlab-ci
  DEV_CLUSTER: ${CI_AWS_ECS_CLUSTER}_dev
  DEV_SERVICE: ${CI_AWS_ECS_SERVICE}
  PROD_CLUSTER: ${CI_AWS_ECS_CLUSTER}_prod
  PROD_SERVICE: ${CI_AWS_ECS_SERVICE}


stages:
  - test
  - docker-dev
  - deploy-dev
  - docker-prod
  - deploy-prod

maven-test:
  image: maven:latest
  stage: test
  script: "mvn test"
  artifacts:
    paths:
      - target/*.jar

docker-build-dev:
  stage: docker-dev
  script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker build -t registry.gitlab.com/sportalorg/backend/athlete-service:dev .
    - docker push registry.gitlab.com/sportalorg/backend/athlete-service:dev

deploy-dev:
  stage: deploy-dev
  image: registry.gitlab.com/gitlab-org/cloud-deploy/aws-base:latest
  script:
    - aws ecs update-service --cluster $DEV_CLUSTER --service $CI_AWS_ECS_SERVICE --task-definition $CI_AWS_ECS_TASK_DEFINITION --force-new-deployment
  when: manual

docker-build-prod:
  stage: docker-prod
  script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker build -t registry.gitlab.com/sportalorg/backend/athlete-service:prod .
    - docker push registry.gitlab.com/sportalorg/backend/athlete-service:prod
  when: manual

deploy-prod:
  stage: deploy-prod
  image: registry.gitlab.com/gitlab-org/cloud-deploy/aws-base:latest
  script:
    - aws ecs update-service --cluster $PROD_CLUSTER --service $CI_AWS_ECS_SERVICE --task-definition $CI_AWS_ECS_TASK_DEFINITION --force-new-deployment
  when: manual
